﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace CrevisFnIoExample
{
    public class FnIO
    {
        // ================================================================================================
        // import Dll   
        //Device Type Define
        public const int  MODBUS_TCP = 0;

        // ktk_Add_20120925
        // FNIO_SYS_CMD
        public const int SYS_VERSION					= 0x00000001;			
	    public const int SYS_VENDOR_NAME				= 0x00000002;	
	    public const int SYS_CONNECTION_TIMEOUT			= 0x00000005;
        public const int SYS_DEVICE_NUM                 = 0x00000006;

        
        // ktk_Add_20120213
        //FNIO_DEV_CMD 

	    // Device Identification
	    public const int DEV_PRODUCT_CODE				= 0x00001002;
	    public const int DEV_FIRMWARE_VERSION			= 0x00001003;
	    public const int DEV_PROCDUCT_NAME				= 0x00001005;
        public const int DEV_FIRMWARE_RELEASE_DATE      = 0x00001007;
	    // Device Time Controls
	    public const int DEV_WATCHDOC_TIME				= 0x00002000;
	    public const int DEV_IO_UPDATE_TIME				= 0x00002004;
	    public const int DEV_MAIN_LOOP_TIME				= 0x00002005;
	    // Device Translayer Controls
	    public const int DEV_CONNECTION_TIMEOUT_TIME	= 0x00003001;
	    public const int DEV_CONNECTED_NUMBER			= 0x00003002;
	    public const int DEV_PORT_NUMBER				= 0x00003003;
	    public const int DEV_INTERFACE_SPEED			= 0x00003004;
	    public const int DEV_BOOTP_ENABLE				= 0x00003005;
	    public const int DEV_ARP_ENABLE					= 0x00003006;
	    public const int DEV_IP_ADDRESS					= 0x00003007;
	    public const int DEV_SUBNET_MASK				= 0x00003008;
	    public const int DEV_GATEWAY					= 0x00003009;
	    public const int DEV_MAC_ID						= 0x0000300A;
	    // Device Informations
	    public const int DEV_EXPANSION_SLOT_NUMBER		= 0x00004009;
	    public const int DEV_ACTIVE_SLOT_NUMBER			= 0x0000400A;
	    public const int DEV_INACTIVE_SLOT_NUMBER		= 0x0000400B;
	    public const int DEV_INPUT_PROCESS_IMAGE_MODE	= 0x0000400D;
	    public const int DEV_OUTPUT_PROCESS_IMAGE_MODE	= 0x0000400E;
	    public const int DEV_INACTIVE_SLOT_LIST			= 0x0000400F;
	    public const int DEV_ACTIVE_SLOT_LIST			= 0x00004010;
	    public const int DEV_ALARM_SLOT_LIST			= 0x00004011;
	    public const int DEV_DEVICE_BUS_STATUS			= 0x00004012;
	    //
	    public const int DEV_DEVICE_RESET				= 0x00005001;
	    //
	    public const int DEV_INPUT_IMAGE_SIZE			= 0x00007000;
	    public const int DEV_OUTPUT_IMAGE_SIZE			= 0x00007001;	
	    // Device Configurations
	    public const int DEV_RECONNECT_TIMEOUT			= 0x00009000;
	    public const int DEV_RESPONSE_TIMEOUT			= 0x00009001;
	    public const int DEV_UPDATE_FREQUENCY			= 0x00009002;
	    public const int DEV_AUTO_CONNECTION			= 0x00009003;
	    public const int DEV_SAFETY_MODE				= 0x00009004;
	    public const int DEV_SAFETY_TIMEOUT				= 0x00009005;
        public const int DEV_RETRY_NUMBER               = 0x00009006;

        // ktk_Add_20120925
        // FNIO_IO_CMD
        public const int IO_INPUT_BIT_SIZE				= 0x0000A008;
	    public const int IO_OUTPUT_BIT_SIZE				= 0x0000A009;
	    public const int IO_ST_NUMBER					= 0x0000A00E;
	    public const int IO_MODULE_DESCRIPTION			= 0x0000A00F;
	    public const int IO_CONFIGURATION_PARAMETER_SIZE = 0x0000A010;
	    public const int IO_CONFIGURATION_PARAMETER		= 0x0000A011;
        public const int IO_FIRMWARE_VERSION            = 0x0000A017;


        // FNIO_DATA_INFO
        public const int DATA_ACCESS_MODE				= 0x00012000;
        public const int DATA_TYPE						= 0x00012001;
        public const int DATA_MIN						= 0x00012003;
        public const int DATA_MAX						= 0x00012004;
        public const int DATA_INC						= 0x00012005;
        public const int DATA_VALUE                     = 0x00012006;

        // ktk_Add_20120925
        // FNIO_ACCESS_MODE
        public const int READ_ONLY						= 0x00013000;
	    public const int WRITE_ONLY						= 0x00013001;
	    public const int READ_WRITE						= 0x00013002;
        public const int NOT_IMPLEMENT                  = 0x00013003;

        // ktk_Add_20120925
        // FNIO_DATATYPE
        public const int DATATYPE_UNKNOWN				= 0x00021000;			
	    public const int DATATYPE_STRING 				= 0x00021001;			
	    public const int DATATYPE_INT8					= 0x00021002;			
	    public const int DATATYPE_UINT8  				= 0x00021003;			
	    public const int DATATYPE_INT16  				= 0x00021004;			
	    public const int DATATYPE_UINT16   				= 0x00021005;			
	    public const int DATATYPE_INT32      			= 0x00021006;			
	    public const int DATATYPE_UINT32  				= 0x00021007;			
	    public const int DATATYPE_INT64       			= 0x00021008;			
	    public const int DATATYPE_UINT64				= 0x00021009;			
	    public const int DATATYPE_FLOAT32         		= 0x0002100A;			
	    public const int DATATYPE_FLOAT64    			= 0x0002100B;
        public const int DATATYPE_HANDLE                = 0x0002100C;	


        // Modbus Response Code ------------------------------------------------------------------------
        public const int NORMAL_RESPONSE = 0;
        public const int CONNECTION_FAIL = -1;
        public const int MAX_CONNECTION_EXCEEDED = -2;
        public const int ILLEGAL_DEVICE_TYPE = -3;

        public const int ILLEGAL_FUNCTION = 1;	                        //Error code : Illegal Function
        public const int ILLEGAL_DATA_ADDRESS = 2;	                    //Error code : Illegal Data Address
        public const int ILLEGAL_DATA_VALUE = 3;	                    //Error code : Illegal Data Value
        public const int SLAVE_DEVICE_FAILURE = 4;	                    //Error code : Slave Device Failure
        public const int ACKNOWLEDGE = 5;	                            //Error code : Acknowledge
        public const int SLAVE_DEVICE_BUSY = 6;	                        //Error code : Slave Device Busy
        public const int MEMORY_PARITY_ERROR = 8;	                    //Error code : Memory Parity Error
        public const int GATEWAY_PATH_UNAVAILABLE = 10;	                //Error code : Gateway Path Unavailable
        public const int GATEWAY_TARGET_DEVICE_FAILED_TO_RESPOND = 11;	//Error code : Gateway Target Device Failed to Respond

        public const int ILLEGAL_RESPONSE = 14;	                        //Error code : Illegal Response				//define by CREVIS
        public const int ILLEGAL_TRANSACTION_ID = 15;	                //Error code : Illegal Transaction ID		//define by CREVIS
        public const int TIMEOUT_RESPONSE = 16;	                        //Error code : Time out response			//define by CREVIS
        public const int NOT_CONNECT = 17;	                            //Error code : Not Connect Device			//define by CREVIS
        public const int ILLEGAL_HANDLE = 18;	                        //Error code : Illegal connection handle	//define by CREVIS
        public const int ILLEGAL_PROTOCOL_TYPE = 19;	                //Error code : Illegal protocol type		//define by CREVIS

        [StructLayout(LayoutKind.Sequential, Pack = 1), Serializable]
        public struct DEVICEINFOMODBUSTCP
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public byte[]   IpAddress;
	        public int		PortNum;
	        public uint	    InputSize;
            public uint     OutputSize;
        };

        [DllImport("CrevisFnIO.dll")]
        public static extern int InitSystem();

        [DllImport("CrevisFnIO.dll")]
        public static extern int FreeSystem();

        [DllImport("CrevisFnIO.dll")]
        public static extern int OpenDevice(ref uint pDevice, ref DEVICEINFOMODBUSTCP pOpenDevInfo, int DeviceType);

        [DllImport("CrevisFnIO.dll")]
        public static extern int DevGetParam(uint hDevice, uint Cmd, uint Info, ref int pData, ref uint pDataSize);     // ktk_Add_20120213

        [DllImport("CrevisFnIO.dll")]
        public static extern int DevSetParam(uint hDevice, uint Cmd, ref int pData, ref uint pDataSize);                // ktk_Add_20120213

        [DllImport("CrevisFnIO.dll")]
        public static extern int CloseDevice(uint hDevice);

        [DllImport("CrevisFnIO.dll")]
        public static extern int ReadInputByteData(uint hDevice, ushort addr, ref byte buffer, ushort len);

        [DllImport("CrevisFnIO.dll")]
        public static extern int ReadOutputByteData(uint hDevice, ushort addr, ref byte buffer, ushort len);

        [DllImport("CrevisFnIO.dll")]
        public static extern int WriteOutputByteData(uint hDevice, ushort addr, ref byte buffer, ushort len);
        // ================================================================================================

        private DEVICEINFOMODBUSTCP m_DevInfo;
        private uint m_hDevice = 0xFFFFFFFF;

        public int FnIoInit()
        {
            m_DevInfo.IpAddress = new byte[4];
            // Modbus Port는 502 고정
            m_DevInfo.PortNum = 502;
            return InitSystem();
        }

        public int FnIoFree()
        {
            return FreeSystem();
        }

        public int FnIoOpenDevice()
        {
            return OpenDevice(ref m_hDevice, ref m_DevInfo, MODBUS_TCP);
        }

        public int FnIoSetIpAddress(byte Ip0, byte Ip1, byte Ip2, byte Ip3)
        {
            m_DevInfo.IpAddress[0] = Ip0;
            m_DevInfo.IpAddress[1] = Ip1;
            m_DevInfo.IpAddress[2] = Ip2;
            m_DevInfo.IpAddress[3] = Ip3;
            return NORMAL_RESPONSE;
        }

        public int FnIoDevGetParamInteger(uint Cmd, uint Info, ref int pData, ref uint pDataSize)
        {
            return DevGetParam(m_hDevice, Cmd, DATA_VALUE, ref pData, ref pDataSize);
        }


        public int FnIoDevSetParamInteger(uint Cmd, ref int pData, ref uint pDataSize)
        {
            return DevSetParam(m_hDevice, Cmd, ref pData, ref pDataSize);
        }

        public int FnIoCloseDevice()
        {
            int ret = CloseDevice(m_hDevice);
            m_hDevice = 0xFFFFFFFF;
            return ret;
        }

        public int FnIoReadInputByteData(ushort addr, ref byte buffer, ushort len)
        {
            return ReadInputByteData(m_hDevice, addr, ref buffer, len);
        }

        public int FnIoReadOutputByteData(ushort addr, ref byte buffer, ushort len)
        {
            return ReadOutputByteData(m_hDevice, addr, ref buffer, len);
        }

        public int FnIoWriteOutputByteData(ushort addr, ref byte buffer, ushort len)
        {
            return WriteOutputByteData(m_hDevice, addr, ref buffer, len);
        }
    }
}
