﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CrevisFnIoExample
{
    public partial class Form1 : Form
    {
        public FnIO                     m_cFnIo = new FnIO();
        
        public byte[] m_buff_write;
        public byte[] m_buff_read;

        public byte m_test_data;

        public Form1()
        {
            InitializeComponent();
            m_cFnIo.FnIoInit();

            // 버퍼 초기화
            m_buff_write = new byte[252];           // 최대 252 Byte 지원
            m_buff_read = new byte[252];            // 최대 252 Byte 지원
        }   

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            m_cFnIo.FnIoFree();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int err;

            // 실제 접속 하고자 하는 IP Address 설정(ex:192.168.0.245)
            err = m_cFnIo.FnIoSetIpAddress(192, 168, 0, 55);
            if (err != FnIO.NORMAL_RESPONSE)
            {
                // 에러 처리
            }

            // Device를 열기
            err = m_cFnIo.FnIoOpenDevice();
            if (err != FnIO.NORMAL_RESPONSE)
            {
                // 에러 처리
            }

            m_test_data = 0;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            int err;

            // Device 사용 종료
            err = m_cFnIo.FnIoCloseDevice();
            if (err != FnIO.NORMAL_RESPONSE)
            {
                // 에러 처리
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {   // Write IO data
            ushort length = 1;      // 실제 연결된 outpot IO size
            int err;

            m_buff_write[0] = 0;

            err = m_cFnIo.FnIoWriteOutputByteData(0, ref m_buff_write[0], length);
            if (err != FnIO.NORMAL_RESPONSE)
            {
                // 에러 처리
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {   // Read IO data
            ushort length = 1;      // 실제 연결된 input IO size
            int err;

            err = m_cFnIo.FnIoReadInputByteData(0, ref m_buff_read[0], length);
            if (err != FnIO.NORMAL_RESPONSE)
            {
                // 에러 처리
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button5_Click(object sender, EventArgs e)
        {
            int err, Data;
            uint size;
            Data = 0;
            size = sizeof(int);

            err = m_cFnIo.FnIoDevSetParamInteger(FnIO.DEV_DEVICE_RESET, ref Data, ref size);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int err;
            ushort length = 1;

            m_test_data++;

            err = m_cFnIo.FnIoWriteOutputByteData(0, ref m_test_data, length);
            if (err != FnIO.NORMAL_RESPONSE)
            {
                textBox1.Text = "Error";
            }
            else
            {
                textBox1.Text = "No error";
            }

        }

        private void button6_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void button7_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
        }

        private void button8_Click(object sender, EventArgs e)
        {
            int err, Data;
            uint size;
            Data = 1;
            size = sizeof(int);

            err = m_cFnIo.FnIoDevSetParamInteger(FnIO.DEV_AUTO_CONNECTION, ref Data, ref size);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            int err, Data;
            uint size;
            Data = 0;
            size = sizeof(int);

            err = m_cFnIo.FnIoDevSetParamInteger(FnIO.DEV_AUTO_CONNECTION, ref Data, ref size);
        }
    }
}
